#include <iostream>
#include "omp.h"
#include "global.h"

int main() {
  std::cout << "running" << std::endl;

  std::cout << "setting g_thread" << std::endl;

  int l_nThreads;

  // init
#pragma omp parallel
{
  g_thread = omp_get_thread_num();

  if( g_thread == 0 ) l_nThreads = omp_get_num_threads();
}



  // print
  std::cout << "printing g_thread" << std::endl;
#pragma omp parallel
{
#pragma omp critical
  std::cout << l_nThreads << " " << g_thread << std::endl;
}




  // side-effect
  std::cout << "working on some side-effects";
#pragma omp parallel for num_threads( std::max( l_nThreads-1, 1 ) )
  for( unsigned short l_i = 0; l_i < 10; l_i++ )
    std::cout << "..."; 
  std::cout << std::endl;




  // print again
  std::cout << "printing g_thread" << std::endl;
#pragma omp parallel
{
#pragma omp critical
  std::cout << l_nThreads << " " << g_thread << std::endl;
}

}
